aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorGravatar Nick Waywood <n.waywood@gmail.com>2020-04-01 23:35:52 +1100
committerGravatar GitHub <noreply@github.com>2020-04-01 18:05:52 +0530
commit553f183919e2326f485eb2cc16309c60b0c3b7a7 (patch)
tree7f461a18a9d969c3c8cec656c298446c9d659e6b
parenta3f509ffc688b2c6db822a759ddb3edfed453333 (diff)
downloadnnn-553f183919e2326f485eb2cc16309c60b0c3b7a7.tar.gz
Added fzfz plugin (#502)
* Added fzfz plugin * Fixed shellcheck errors * Fixed copy/paste error
-rw-r--r--plugins/README.md1
-rwxr-xr-xplugins/fzfz23
2 files changed, 24 insertions, 0 deletions
diff --git a/plugins/README.md b/plugins/README.md
index 7bee546..156e786 100644
--- a/plugins/README.md
+++ b/plugins/README.md
@@ -33,6 +33,7 @@ Plugins are installed to `${XDG_CONFIG_HOME:-$HOME/.config}/nnn/plugins`.
| diffs | Diff for selection (limited to 2 for directories) | sh | vimdiff |
| dragdrop | Drag/drop files from/into nnn | sh | [dragon](https://github.com/mwh/dragon) |
| fzcd | Change to the directory of a fuzzy-selected file/dir | sh | fzf/fzy<br>fd/fdfind/find |
+| fzfz | Change to any directory in the z database with fzf | sh | fzf, z |
| fzhist | Fuzzy-select a cmd from history, edit in `$EDITOR` and run | sh | fzf/fzy |
| fzopen | Fuzzy find a file in dir subtree and edit or open | sh | fzf/fzy, xdg-open |
| getplugs | Update plugins | sh | curl |
diff --git a/plugins/fzfz b/plugins/fzfz
new file mode 100755
index 0000000..cb5e08a
--- /dev/null
+++ b/plugins/fzfz
@@ -0,0 +1,23 @@
+#!/usr/bin/env sh
+
+# Description: cd to any dir in the z database using an fzf pane
+#
+# Shell: POSIX compliant
+# Author: Nick Waywood
+
+. "$(dirname "$0")"/.nnn-plugin-helper
+
+if [ "$(cmd_exists fzf)" -eq "0" ]; then
+ if [ -f "$HOME/.z" ]; then
+ # I read the data from z's file instead of calling the z command so that the data doesn't need to be processed twice
+ sel=$(awk -F "|" '{print $1}' "$HOME/.z" | fzf | awk '{$1=$1};1')
+ # NOTE: Uncomment this line and comment out the line above if you want to see the weightings of the dir's in the fzf pane
+ # sel=$(awk -F "|" '{printf "%s %s\n", $2, $1}' "$HOME/.z" | fzf | sed 's/^[0-9,.]* *//' | awk '{$1=$1};1')
+ else
+ exit 1
+ fi
+else
+ exit 1
+fi
+
+printf "%s" "0$sel" > "$NNN_PIPE"